/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PropRole
 *  fire.pb.battle.BattleEndHandler
 *  fire.pb.battle.PNewBattle
 *  fire.pb.course.CourseManager
 *  fire.pb.map.SceneNpcManager
 *  fire.pb.npc.NpcManager
 *  fire.pb.npc.SNpcShare
 *  fire.pb.npc.SWinnerChangeTask
 *  fire.pb.school.School
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.Team
 *  fire.pb.team.TeamManager
 *  fire.pb.util.MessageUtil
 *  fire.pb.util.TaskDlgUtil
 *  gnet.link.Onlines
 *  mkio.Protocol
 *  xbean.ProfessionLeaderInfo
 *  xbean.Properties
 *  xbean.TaskDlgInfo
 *  xbean.TaskInfos
 *  xtable.Professionleader
 *  xtable.Properties
 *  xtable.Roletasks
 */
package fire.pb.activity.winner;

import fire.pb.PropRole;
import fire.pb.activity.winner.WinnerEndHandler;
import fire.pb.activity.winner.WinnerManager;
import fire.pb.activity.winner.WinnerRecord;
import fire.pb.battle.BattleEndHandler;
import fire.pb.battle.PNewBattle;
import fire.pb.course.CourseManager;
import fire.pb.map.SceneNpcManager;
import fire.pb.npc.NpcManager;
import fire.pb.npc.SNpcShare;
import fire.pb.npc.SWinnerChangeTask;
import fire.pb.school.School;
import fire.pb.talk.MessageMgr;
import fire.pb.team.Team;
import fire.pb.team.TeamManager;
import fire.pb.util.MessageUtil;
import fire.pb.util.TaskDlgUtil;
import gnet.link.Onlines;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import mkio.Protocol;
import xbean.ProfessionLeaderInfo;
import xbean.TaskDlgInfo;
import xbean.TaskInfos;
import xtable.Professionleader;
import xtable.Properties;
import xtable.Roletasks;

public class CStartWinnerBattle {
    private final long roleid;
    private final long npckey;

    public CStartWinnerBattle(long roleid, long npckey) {
        this.roleid = roleid;
        this.npckey = npckey;
    }

    public void process() {
        xbean.Properties prop;
        ProfessionLeaderInfo pl;
        int npccode = SceneNpcManager.selectNpcByKey((long)this.npckey).getNpcID();
        if (!TaskDlgUtil.existTask((long)this.roleid, (int)701002)) {
            MessageMgr.sendMsgNotify((long)this.roleid, (int)141546, (int)npccode, null);
            return;
        }
        TaskInfos taskInfos = Roletasks.select((Long)this.roleid);
        if (taskInfos == null) {
            return;
        }
        TaskDlgInfo taskDlgInfo = (TaskDlgInfo)taskInfos.getTasksmap().get(701002);
        if (taskDlgInfo == null) {
            return;
        }
        if (taskDlgInfo.getDstnpcid() != npccode) {
            MessageMgr.sendMsgNotify((long)this.roleid, (int)141546, (int)npccode, null);
            return;
        }
        Team team = TeamManager.selectTeamByRoleId((long)this.roleid);
        if (team == null) {
            MessageMgr.sendMsgNotify((long)this.roleid, (int)140681, (int)npccode, null);
            return;
        }
        if (team.isAbsentMember(this.roleid)) {
            MessageMgr.sendMsgNotify((long)this.roleid, (int)140669, (int)npccode, null);
            return;
        }
        long teamid = team.teamId;
        WinnerRecord record = WinnerManager.getInstance().teams.get(teamid);
        if (record == null) {
            MessageMgr.sendMsgNotify((long)this.roleid, (int)140681, (int)npccode, null);
            return;
        }
        if (!WinnerManager.getInstance().isInWinnerActiveTime(record.getRoundStartTime())) {
            MessageMgr.sendMsgNotify((long)this.roleid, (int)140681, (int)npccode, null);
            return;
        }
        List teamMembers = team.getNormalMemberIds();
        int num = teamMembers.size();
        if (num < 3) {
            for (Long mem : teamMembers) {
                MessageMgr.sendMsgNotify((long)mem, (int)140669, (int)npccode, null);
            }
            return;
        }
        ArrayList<Long> less_level = new ArrayList<Long>();
        ArrayList<Long> nothavetask = new ArrayList<Long>();
        TaskDlgInfo leadertask = TaskDlgUtil.selecTaskDlgInfo((long)this.roleid, (int)701002);
        Iterator iterator = teamMembers.iterator();
        while (iterator.hasNext()) {
            long member = (Long)iterator.next();
            PropRole role = new PropRole(member, true);
            if (role.getLevel() < 40) {
                less_level.add(member);
            }
            if (member == this.roleid) continue;
            TaskDlgInfo task = TaskDlgUtil.selecTaskDlgInfo((long)member, (int)701002);
            if (task == null) {
                nothavetask.add(member);
                continue;
            }
            if (task.getDstnpcid() == leadertask.getDstnpcid() && task.getSumnum() == leadertask.getSumnum() && task.getTaskstate() == 4) continue;
            nothavetask.add(member);
        }
        if (!less_level.isEmpty()) {
            String roleNames = MessageUtil.getRoleNames(less_level);
            List paras = MessageUtil.getMsgParaList((String[])new String[]{roleNames});
            for (Long mem : teamMembers) {
                MessageMgr.sendMsgNotify((long)mem, (int)140670, (int)npccode, (List)paras);
            }
            return;
        }
        if (!nothavetask.isEmpty()) {
            for (Long mem : nothavetask) {
                SWinnerChangeTask sWinnerChangeTask = new SWinnerChangeTask();
                Onlines.getInstance().send(mem, (Protocol)sWinnerChangeTask);
            }
            MessageMgr.sendMsgNotify((long)this.roleid, (int)140681, (int)npccode, null);
            return;
        }
        if (!WinnerManager.getInstance().haveNpcBycode(npccode)) {
            MessageMgr.sendMsgNotify((long)this.roleid, (int)140684, (int)npccode, null);
            return;
        }
        SNpcShare share = NpcManager.getInstance().getNpcShareByID(npccode);
        if (share == null) {
            return;
        }
        WinnerManager.getInstance().reloadTeamInfo(teamid, record);
        for (Long mem : teamMembers) {
            CourseManager.achieveCourse((long)mem, (int)10, (int)208, (int)0);
        }
        School s = School.getSchoolByFighterWinner((int)share.getId());
        if (s != null && (pl = Professionleader.select((Integer)s.getValue())) != null && (prop = Properties.select((Long)pl.getRoleid())) != null) {
            new PNewBattle(this.roleid, share.getBattleinfo(), 20, prop.getRolename(), (BattleEndHandler)new WinnerEndHandler(teamid, npccode)).submit();
            return;
        }
        new PNewBattle(this.roleid, share.getBattleinfo(), (BattleEndHandler)new WinnerEndHandler(teamid, npccode)).submit();
    }
}

